#include <SPI.h>                              // Include SPI library

byte address = 0x00;                          // Digital Pot address
int i;                                        // Digital Pot counter index
#define CS 10                                 // Digital Pot Chip Select pin
#define trigPin 6                             // Define Ultrasonic transducer trigger pin
#define echoPin 7                             // Define Ultrasonic transducer echo pin
#define f1 2                                  // Define f1 switch control pin                          
#define f2 3                                  // Define f2 switch control pin  
#define f3 4                                  // Define f3 switch control pin  
#define f4 5                                  // Define f4 switch control pin  
#define f5 A0                                 // Define f5 switch control pin  
#define f6 A1                                 // Define f6 switch control pin  
#define f7 A2                                 // Define f7 switch control pin  
#define f8 A3                                 // Define f8 switch control pin  

void setup() {
  Serial.begin (9600);                        // Start Serial Monitor communication
  SPI.begin();                                // Start SPI communication
  pinMode (CS, OUTPUT);                       // Define all pins as inputs or outputs as below
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(f1, OUTPUT);
  pinMode(f2, OUTPUT);
  pinMode(f3, OUTPUT);
  pinMode(f4, OUTPUT);
  pinMode(A0, OUTPUT);
  pinMode(A1, OUTPUT);
  pinMode(A2, OUTPUT);
  pinMode(A3, OUTPUT);
}

void loop() {
  digitalPotWrite(0);                         // Set digital pot wiper to zero
for (i = 0; i <= 128; i=i+16)                 // Increment digital pot setting in steps of 16

{
digitalPotWrite(i);                           // Write the incremental dig pot value to the pot
delay(200);

  long duration, distance;                    // Define duration and distance variables
  digitalWrite(trigPin, LOW);                 // pull trigger pin low 
  delayMicroseconds(2); 
  digitalWrite(trigPin, HIGH);                // pull trigger pin high - initiate a ping

  delayMicroseconds(10); 
  digitalWrite(trigPin, LOW);                 // pull trigger pin low
  duration = pulseIn(echoPin, HIGH);          // Check for time until echo pin goes high
  distance = (duration/2) / 29.1;             // calculate distance in cm
  
  if (distance <= 10) {                       // If distance less than 10 cm
    
    digitalWrite(f1, HIGH);                   // Activate the digital switch for f1 (frequency 1)
    digitalWrite(f2, LOW);
    digitalWrite(f3, LOW);
    digitalWrite(f4, LOW);
    digitalWrite(f5, LOW);
    digitalWrite(f6, LOW);
    digitalWrite(f7, LOW);
    digitalWrite(f8, LOW);
    
    }
  else if (distance > 10 && distance <=20) { // If distance between 10 cm and 20 cm
                                             // Activate the digital switch for f2 (frequency 2)
    digitalWrite(f1, LOW);
    digitalWrite(f2, HIGH);
    digitalWrite(f3, LOW);
    digitalWrite(f4, LOW);
    digitalWrite(f5, LOW);
    digitalWrite(f6, LOW);
    digitalWrite(f7, LOW);
    digitalWrite(f8, LOW);
    
    }
  else if (distance >20 && distance <=30) { 
    
    digitalWrite(f1, LOW);
    digitalWrite(f2, LOW);
    digitalWrite(f3, HIGH);
    digitalWrite(f4, LOW);
    digitalWrite(f5, LOW);
    digitalWrite(f6, LOW);
    digitalWrite(f7, LOW);
    digitalWrite(f8, LOW);
    
    }
  else if (distance >30 && distance <=40) { 
   
    digitalWrite(f1, LOW);
    digitalWrite(f2, LOW);
    digitalWrite(f3, LOW);
    digitalWrite(f4, HIGH);
    digitalWrite(f5, LOW);
    digitalWrite(f6, LOW);
    digitalWrite(f7, LOW);
    digitalWrite(f8, LOW);
    
    }
    else if (distance >40 && distance <=50) { 
   
    digitalWrite(f1, LOW);
    digitalWrite(f2, LOW);
    digitalWrite(f3, LOW);
    digitalWrite(f4, LOW);
    digitalWrite(f5, HIGH);
    digitalWrite(f6, LOW);
    digitalWrite(f7, LOW);
    digitalWrite(f8, LOW);
    
    }
  else if (distance >50 && distance <=60) { 
   
    digitalWrite(f1, LOW);
    digitalWrite(f2, LOW);
    digitalWrite(f3, LOW);
    digitalWrite(f4, LOW);
    digitalWrite(f5, LOW);
    digitalWrite(f6, HIGH);
    digitalWrite(f7, LOW);
    digitalWrite(f8, LOW);
    
    }
  else if (distance >60 && distance <=70) { 
   
    digitalWrite(f1, LOW);
    digitalWrite(f2, LOW);
    digitalWrite(f3, LOW);
    digitalWrite(f4, LOW);
    digitalWrite(f5, LOW);
    digitalWrite(f6, LOW);
    digitalWrite(f7, HIGH);
    digitalWrite(f8, LOW);
    
    }
  else if (distance >70) { 
   
    digitalWrite(f1, LOW);
    digitalWrite(f2, LOW);
    digitalWrite(f3, LOW);
    digitalWrite(f4, LOW);
    digitalWrite(f5, LOW);
    digitalWrite(f6, LOW);
    digitalWrite(f7, LOW);
    digitalWrite(f8, HIGH);
    
    }
  //if (distance >= 400 || distance <= 0){
    //Serial.println("Out of range");
  //}
  //else {
   // Serial.print(distance);
   // Serial.println(" cm");
    //Serial.println(i);
  //}
  delay(100);
}
 }
int digitalPotWrite(int value)                // The routine that writes current i - increment value to the dig pot
{
digitalWrite(CS, LOW);                        // Pull chip select low to select dig pot
SPI.transfer(address);                        // Send address byte
SPI.transfer(value);                          // Send current value to the pot via SPI
digitalWrite(CS, HIGH);                       // Pull chip selct high to deselect dig pot
}
